﻿Imports System.Data
Imports System.Data.SqlClient
Public Class Form1
    Private Const ConnectionString As String = "Data Source=.\SQL2017;Initial Catalog=AjaxSamples;Integrated Security = true"
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.BindGrid()
    End Sub

    Private Sub BindGrid()
        'Hide the last blank line.
        dataGridView1.AllowUserToAddRows = False

        'Clear Columns.
        dataGridView1.Columns.Clear()

        'Add Columns.
        Dim customerId As DataGridViewColumn = New DataGridViewTextBoxColumn()
        customerId.Name = "CustomerId"
        customerId.HeaderText = "CustomerId Id"
        customerId.DataPropertyName = "CustomerId"
        customerId.Width = 100
        dataGridView1.Columns.Insert(0, customerId)

        Dim name As DataGridViewColumn = New DataGridViewTextBoxColumn()
        name.HeaderText = "Name"
        name.Name = "Name"
        name.DataPropertyName = "Name"
        name.Width = 100
        dataGridView1.Columns.Insert(1, name)

        Dim country As DataGridViewColumn = New DataGridViewTextBoxColumn()
        country.Name = "Country"
        country.HeaderText = "Country"
        country.DataPropertyName = "Country"
        country.Width = 100
        dataGridView1.Columns.Insert(2, country)

        'Bind the DataGridView.
        dataGridView1.DataSource = Nothing
        Using con As SqlConnection = New SqlConnection(ConnectionString)

            Using cmd As SqlCommand = New SqlCommand("SELECT CustomerId, Name, Country FROM Customers", con)
                cmd.CommandType = CommandType.Text
                Using sda As SqlDataAdapter = New SqlDataAdapter(cmd)
                    Using dt As DataTable = New DataTable()
                        sda.Fill(dt)
                        dataGridView1.DataSource = dt
                    End Using
                End Using
            End Using
        End Using

        'Add the Button Column.
        Dim buttonColumn As DataGridViewButtonColumn = New DataGridViewButtonColumn()
        buttonColumn.HeaderText = ""
        buttonColumn.Width = 60
        buttonColumn.Name = "buttonColumn"
        buttonColumn.Text = "Delete"
        buttonColumn.UseColumnTextForButtonValue = True
        dataGridView1.Columns.Insert(3, buttonColumn)
    End Sub

    Private Sub dataGridView1_CellContentClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dataGridView1.CellContentClick
        If e.ColumnIndex = 3 Then
            Dim row As DataGridViewRow = dataGridView1.Rows(e.RowIndex)
            If MessageBox.Show(String.Format("Do you want to delete Customer ID: {0}", row.Cells("CustomerId").Value), "Confirmation", MessageBoxButtons.YesNo) = DialogResult.Yes Then
                Using con As New SqlConnection(ConnectionString)
                    Using cmd As New SqlCommand("DELETE FROM Customers WHERE CustomerId = @CustomerId", con)
                        cmd.CommandType = CommandType.Text
                        cmd.Parameters.AddWithValue("@CustomerId", row.Cells("CustomerId").Value)
                        con.Open()
                        cmd.ExecuteNonQuery()
                        con.Close()
                    End Using
                End Using

                Me.BindGrid()
            End If
        End If
    End Sub
End Class
